--- sat-solver/CMakeLists.txt.ark	2009-06-01 16:55:22.849556547 +0200
+++ sat-solver/CMakeLists.txt	2009-06-01 16:56:14.260201942 +0200
@@ -36,11 +36,17 @@ FIND_PACKAGE(Check REQUIRED)
 FIND_PACKAGE(ZLIB REQUIRED)
 
 IF ( FEDORA )
-MESSAGE(STATUS "Building for Fedora")
-ADD_DEFINITIONS( -DFEDORA )
-FIND_LIBRARY(RPMDB_LIBRARY NAMES rpm)
+  MESSAGE(STATUS "Building for Fedora")
+  ADD_DEFINITIONS( -DFEDORA )
+  FIND_LIBRARY(RPMDB_LIBRARY NAMES rpm)
 ELSE ( FEDORA )
-FIND_LIBRARY(RPMDB_LIBRARY NAMES rpmdb)
+  IF ( ARK )
+    MESSAGE(STATUS "Building for Ark")
+    ADD_DEFINITIONS( -DARK )
+    FIND_LIBRARY(RPMDB_LIBRARY NAMES rpm)
+  ELSE ( ARK )
+    FIND_LIBRARY(RPMDB_LIBRARY NAMES rpmdb)
+  ENDIF ( ARK )
 ENDIF ( FEDORA)
 
 SET( PACKAGE "satsolver" )
--- sat-solver/tools/repo_rpmdb.c.ark	2009-05-31 22:25:01.000000000 +0200
+++ sat-solver/tools/repo_rpmdb.c	2009-06-01 16:57:25.717557920 +0200
@@ -22,7 +22,7 @@
 #include <unistd.h>
 #include <assert.h>
 
-#ifdef FEDORA
+#if defined(FEDORA) || defined(ARK)
 #include <db4/db.h>
 #else
 #include <rpm/db.h>
@@ -1309,7 +1309,11 @@ repo_add_rpmdb(Repo *repo, Repo *ref, co
 
       if ((flags & RPMDB_REPORT_PROGRESS) != 0)
 	count = count_headers(rootdir, dbenv);
+#ifdef ARK
+      if (db->open(db, 0, dbpath, 0, DB_BTREE, DB_RDONLY, 0664))
+#else
       if (db->open(db, 0, dbpath, 0, DB_HASH, DB_RDONLY, 0664))
+#endif
 	{
 	  perror("db->open var/lib/rpm/Packages");
 	  exit(1);
